stages:
     - build
     - test
     - sonar
     - quality
     - package

image: openjdk:8-alpine

variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
    GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task

cache:
    paths:
        - .m2/repository
    key: "$CI_JOB_NAME"

build_job:
    stage: build
    script:
        - chmod +x mvnw
        - ./mvnw compile -Dmaven.test.skip=true
        - ./mvnw compile
          -Dhttps.protocols=TLSv1.2
          -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository
          -Djava.awt.headless=true
          --batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true

test_job:
    stage: test
    script:
        - chmod +x mvnw
        - ./mvnw test

sonarcloud-check:
    stage: sonar
    image: maven:3-openjdk-17
    cache:
        key: "${CI_JOB_NAME}"
        paths:
        - .sonar/cache
    script:
        - chmod +x mvnw
        - ./mvnw verify sonar:sonar -Dsonar.projectKey=Martin.gentit_tp_note_cicd
    only:
        - merge_requests
        - main
        - feature
        - develop

qualitiy_job:
    stage: quality
    image: docker:stable
    variables:
        DOCKER_HOST: tcp://docker:2375/
        DOCKER_DRIVER: overlay2
        DOCKER_LTS_CERTIDR: ""
    allow_failure: true
    services:
       - name: docker:dind
         alias: docker 
         entrypoint: ["dockerd-entrypoint.sh", "--tls=false"]
    script:
        - chmod +x mvnw
        - mkdir codequality-results
        - docker run
          --env CODECLIMATE_CODE="$PWD"
          --volume "$PWD":/code
          --volume /var/run/docker.sock:/var/run/docker.sock
          --volume /tmp/cc:/tmp/cc
          codeclimate/codeclimate analyze -f html > ./codequality-results/index.html
    artifacts:
        paths:
            - codequality-results/
